var NAVTREE =
[
  [ "CGAL 4.7 - Manual", "index.html", [
    [ "Getting Started", "general_intro.html", "general_intro" ],
    [ "Package Overview", "packages.html", [
      [ "Arithmetic and Algebra", "packages.html#PartAlgebraicFoundations", [
        [ "Algebraic Foundations", "packages.html#PkgAlgebraicFoundationsSummary", null ],
        [ "Number Types", "packages.html#PkgNumberTypesSummary", null ],
        [ "Modular Arithmetic", "packages.html#PkgModularArithmeticSummary", null ],
        [ "Polynomial", "packages.html#PkgPolynomialSummary", null ],
        [ "Algebraic Kernel", "packages.html#PkgAlgebraicKerneldSummary", null ]
      ] ],
      [ "Combinatorial Algorithms", "packages.html#PartCombinatorialAlgorithms", [
        [ "Monotone and Sorted Matrix Search", "packages.html#PkgMatrixSearchSummary", null ],
        [ "Linear and Quadratic Programming Solver", "packages.html#PkgQPSolverSummary", null ]
      ] ],
      [ "Geometry Kernels", "packages.html#PartKernels", [
        [ "2D and 3D Linear Geometry Kernel", "packages.html#PkgKernel23Summary", null ],
        [ "dD Geometry Kernel", "packages.html#PkgKernelDSummary", null ],
        [ "2D Circular Geometry Kernel", "packages.html#PkgCircularKernel2Summary", null ],
        [ "3D Spherical Geometry Kernel", "packages.html#PkgSphericalKernel3Summary", null ]
      ] ],
      [ "Convex Hull Algorithms", "packages.html#PartConvexHullAlgorithms", [
        [ "2D Convex Hulls and Extreme Points", "packages.html#PkgConvexHull2Summary", null ],
        [ "3D Convex Hulls", "packages.html#PkgConvexHull3Summary", null ],
        [ "dD Convex Hulls and Delaunay Triangulations", "packages.html#PkgConvexHullDSummary", null ]
      ] ],
      [ "Polygons", "packages.html#PartPolygons", [
        [ "2D Polygons", "packages.html#PkgPolygon2Summary", null ],
        [ "2D Regularized Boolean Set-Operations", "packages.html#PkgBooleanSetOperations2Summary", null ],
        [ "2D Boolean Operations on Nef Polygons", "packages.html#PkgNef2Summary", null ],
        [ "2D Boolean Operations on Nef Polygons Embedded on the Sphere", "packages.html#PkgNefS2Summary", null ],
        [ "2D Polygon Partitioning", "packages.html#PkgPolygonPartitioning2Summary", null ],
        [ "2D Straight Skeleton and Polygon Offsetting", "packages.html#PkgStraightSkeleton2Summary", null ],
        [ "2D Minkowski Sums", "packages.html#PkgMinkowskiSum2Summary", null ],
        [ "2D Polyline Simplification", "packages.html#PkgPolylineSimplification2Summary", null ],
        [ "2D Visibility Computation", "packages.html#PkgVisibility_2Summary", null ]
      ] ],
      [ "Cell Complexes and Polyhedra", "packages.html#PartPolyhedra", [
        [ "3D Polyhedral Surface", "packages.html#PkgPolyhedronSummary", null ],
        [ "Halfedge Data Structures", "packages.html#PkgHDSSummary", null ],
        [ "Surface Mesh", "packages.html#PkgSurfaceMeshSummary", null ],
        [ "Combinatorial Maps", "packages.html#PkgCombinatorialMapsSummary", null ],
        [ "Linear Cell Complex", "packages.html#PkgLinearCellComplexSummary", null ],
        [ "3D Boolean Operations on Nef Polyhedra", "packages.html#PkgNef3Summary", null ],
        [ "Convex Decomposition of Polyhedra", "packages.html#PkgConvexDecomposition3Summary", null ],
        [ "3D Minkowski Sum of Polyhedra", "packages.html#PkgMinkowskiSum3Summary", null ]
      ] ],
      [ "Arrangements", "packages.html#PartArrangements", [
        [ "2D Arrangements", "packages.html#PkgArrangement2Summary", null ],
        [ "2D Intersection of Curves", "packages.html#PkgIntersectionOfCurves2Summary", null ],
        [ "2D Snap Rounding", "packages.html#PkgSnapRounding2Summary", null ],
        [ "2D Envelopes", "packages.html#PkgEnvelope2Summary", null ],
        [ "3D Envelopes", "packages.html#PkgEnvelope3Summary", null ]
      ] ],
      [ "Triangulations and Delaunay Triangulations", "packages.html#PartTriangulationsAndDelaunayTriangulations", [
        [ "2D Triangulation", "packages.html#PkgTriangulation2Summary", null ],
        [ "2D Triangulation Data Structure", "packages.html#PkgTDS2Summary", null ],
        [ "2D Periodic Triangulations", "packages.html#PkgPeriodic2Triangulation2Summary", null ],
        [ "3D Triangulations", "packages.html#PkgTriangulation3Summary", null ],
        [ "3D Triangulation Data Structure", "packages.html#PkgTDS3Summary", null ],
        [ "3D Periodic Triangulations", "packages.html#PkgPeriodic3Triangulation3Summary", null ],
        [ "dD Triangulations", "packages.html#PkgTriangulationsSummary", null ],
        [ "2D Alpha Shapes", "packages.html#PkgAlphaShape2Summary", null ],
        [ "3D Alpha Shapes", "packages.html#PkgAlphaShapes3Summary", null ]
      ] ],
      [ "Voronoi Diagrams", "packages.html#PartVoronoiDiagrams", [
        [ "2D Segment Delaunay Graphs", "packages.html#PkgSegmentDelaunayGraph2Summary", null ],
        [ "L Infinity Segment Delaunay Graphs", "packages.html#PkgSDGLinfSummary", null ],
        [ "2D Apollonius Graphs (Delaunay Graphs of Disks)", "packages.html#PkgApolloniusGraph2Summary", null ],
        [ "2D Voronoi Diagram Adaptor", "packages.html#PkgVoronoiDiagramAdaptor2Summary", null ]
      ] ],
      [ "Mesh Generation", "packages.html#PartMeshing", [
        [ "2D Conforming Triangulations and Meshes", "packages.html#PkgMesh2Summary", null ],
        [ "3D Surface Mesh Generation", "packages.html#PkgSurfaceMesher3Summary", null ],
        [ "Surface Reconstruction from Point Sets", "packages.html#PkgSurfaceReconstructionFromPointSetsSummary", null ],
        [ "Scale-Space Surface Reconstruction", "packages.html#PkgScaleSpaceReconstruction3Summary", null ],
        [ "Advancing Front Surface Reconstruction", "packages.html#PkgAdvancingFrontSurfaceReconstructionSummary", null ],
        [ "3D Skin Surface Meshing", "packages.html#PkgSkinSurface3Summary", null ],
        [ "3D Mesh Generation", "packages.html#PkgMesh_3Summary", null ]
      ] ],
      [ "Geometry Processing", "packages.html#PartGeometryProcessing", [
        [ "Polygon Mesh Processing", "packages.html#PkgPolygonMeshProcessingSummary", null ],
        [ "3D Surface Subdivision Methods", "packages.html#PkgSurfaceSubdivisionMethods3Summary", null ],
        [ "Triangulated Surface Mesh Segmentation", "packages.html#PkgSurfaceSegmentationSummary", null ],
        [ "Triangulated Surface Mesh Simplification", "packages.html#PkgSurfaceMeshSimplificationSummary", null ],
        [ "Triangulated Surface Mesh Deformation", "packages.html#PkgSurfaceModelingSummary", null ],
        [ "Planar Parameterization of Triangulated Surface Meshes", "packages.html#PkgSurfaceParameterizationSummary", null ],
        [ "Triangulated Surface Mesh Shortest Paths", "packages.html#PkgSurfaceMeshShortestPathSummary", null ],
        [ "Triangulated Surface Mesh Skeletonization", "packages.html#PkgMeanCurvatureSkeleton3Summary", null ],
        [ "Approximation of Ridges and Umbilics on Triangulated Surface Meshes", "packages.html#PkgRidges_3Summary", null ],
        [ "Estimation of Local Differential Properties of Point-Sampled Surfaces", "packages.html#PkgJet_fitting_3Summary", null ],
        [ "Point Set Processing", "packages.html#PkgPointSetProcessingSummary", null ],
        [ "Point Set Shape Detection", "packages.html#PkgPointSetShapeDetection3Summary", null ],
        [ "2D Placement of Streamlines", "packages.html#PkgPlacementOfStreamlines2Summary", null ]
      ] ],
      [ "Spatial Searching and Sorting", "packages.html#PartSearchStructures", [
        [ "2D Range and Neighbor Search", "packages.html#PkgPointSet2Summary", null ],
        [ "Interval Skip List", "packages.html#PkgIntervalSkipListSummary", null ],
        [ "dD Spatial Searching", "packages.html#PkgSpatialSearchingDSummary", null ],
        [ "dD Range and Segment Trees", "packages.html#PkgRangeSegmentTreesDSummary", null ],
        [ "Intersecting Sequences of dD Iso-oriented Boxes", "packages.html#PkgBoxIntersectionDSummary", null ],
        [ "3D Fast Intersection and Distance Computation", "packages.html#PkgAABB_treeSummary", null ],
        [ "Spatial Sorting", "packages.html#PkgSpatialSortingSummary", null ]
      ] ],
      [ "Geometric Optimization", "packages.html#PartGeometricOptimization", [
        [ "Bounding Volumes", "packages.html#PkgBoundingVolumesSummary", null ],
        [ "Inscribed Areas", "packages.html#PkgInscribedAreasSummary", null ],
        [ "Optimal Distances", "packages.html#PkgOptimalDistancesSummary", null ],
        [ "Principal Component Analysis", "packages.html#PkgPrincipalComponentAnalysisDSummary", null ]
      ] ],
      [ "Interpolation", "packages.html#PartInterpolation", [
        [ "2D and Surface Function Interpolation", "packages.html#PkgInterpolation2Summary", null ],
        [ "2D Generalized Barycentric Coordinates", "packages.html#PkgBarycentric_coordinates_2Summary", null ]
      ] ],
      [ "Kinetic Data Structures", "packages.html#PartKineticDataStructures", [
        [ "Kinetic Data Structures", "packages.html#PkgKdsSummary", null ],
        [ "Kinetic Framework", "packages.html#PkgKdsFrameworkSummary", null ]
      ] ],
      [ "Support Library", "packages.html#PartSupportLibrary", [
        [ "STL Extensions for CGAL", "packages.html#PkgStlExtensionSummary", null ],
        [ "CGAL and the Boost Graph Library", "packages.html#PkgBGLSummary", null ],
        [ "CGAL and Boost Property Maps", "packages.html#PkgProperty_mapSummary", null ],
        [ "Handles and Circulators", "packages.html#PkgHandlesAndCirculatorsSummary", null ],
        [ "Geometric Object Generators", "packages.html#PkgGeneratorsSummary", null ],
        [ "Profiling tools, Hash Map, Union-find, Modifiers", "packages.html#PkgProfilingToolsSummary", null ],
        [ "IO Streams", "packages.html#PkgIOstreamsSummary", null ]
      ] ],
      [ "Visualization", "packages.html#PartVisualization", [
        [ "Geomview", "packages.html#PkgGeomviewSummary", null ],
        [ "CGAL and the Qt Graphics View Framework", "packages.html#PkgGraphicsViewSummary", null ],
        [ "CGAL Ipelets", "packages.html#PkgCGALIpeletsSummary", null ]
      ] ]
    ] ],
    [ "Developer Manual", "dev_manual.html", "dev_manual" ],
    [ "Acknowledging CGAL", "how_to_cite_cgal.html", null ],
    [ "Bibliographic References", "citelist.html", null ],
    [ "Class and Concept List", "annotated.html", "annotated" ]
  ] ]
];

var NAVTREEINDEX =
[
".html",
"classAlgebraicKernel__d__1_1_1Compare__1.html#a2abf23c2bf3980a31ffdd02336a90416",
"classAlphaShapeCell__3.html#aa6f8e4433d4442bc8a5f903390837100",
"classArrangementDcelHalfedge.html#ae345665fa14b70a6664c236e0ca2bae9",
"classBisectionGeometricTraits__3.html#aa8ea39d3547e3ef4d9c02ddcdf950974",
"classCGAL_1_1Alpha__shape__3.html#a064e4747c9d0108663375a1483c044b4",
"classCGAL_1_1Arr__Bezier__curve__traits__2_1_1Point__2.html#a45b89e6ed04c5740724a76c8249fd8f8",
"classCGAL_1_1Arr__linear__traits__2_1_1Curve__2.html#ae0ab6fd9600b73282c5b1ba5afc9e0c9",
"classCGAL_1_1Arr__rational__function__traits__2_1_1Curve__2.html#adef4be09d4f61087bf59078eaef0bcd6",
"classCGAL_1_1Cell__attribute.html#ab3702662d6192d1125d9c64a0d17466e",
"classCGAL_1_1Concurrent__compact__container.html#a53fc2f489fc94ff57fb20c2efe0a587e",
"classCGAL_1_1Convex__hull__d.html#ae1b4367940f288092b0064548fde5698",
"classCGAL_1_1Delaunay__triangulation__3.html#a0afdebf025f85443ef68138fc80e5fc0",
"classCGAL_1_1Exact__predicates__exact__constructions__kernel__with__kth__root.html",
"classCGAL_1_1General__polygon__set__2.html#ac160e6c607b309d19b389258342b0505",
"classCGAL_1_1HalfedgeDS__decorator.html#a767c212cf2f69d3e3ca4ca9f8c5fb017",
"classCGAL_1_1In__place__list.html#adbfd79857149900f9113fd880784e35f",
"classCGAL_1_1Join__input__iterator__3.html#a5d75cdc65d5a5278367fc227a47dace8",
"classCGAL_1_1Linear__cell__complex.html#a5a340b9b7df50e052588f1b5fb9f672c",
"classCGAL_1_1Min__ellipse__2.html#a0e99b0a15cb7cd39f5ab095b034ec004",
"classCGAL_1_1Monge__via__jet__fitting_1_1Monge__form.html#ab8ce0fb3d33ab6970eefa7f345e4283a",
"classCGAL_1_1Nef__polyhedron__3.html#add465c7cd3aa3f6b0eae8a7171e1e12e",
"classCGAL_1_1Nef__polyhedron__S2_1_1Sphere__point.html#a4b23479df91835144f34203e2f8a1dbf",
"classCGAL_1_1Periodic__2__triangulation__2.html#a420493d5ba78daa8cdeef1be51a70d18",
"classCGAL_1_1Periodic__3__triangulation__3.html#a6dea728760cf26b1cc57c28f84a48f63",
"classCGAL_1_1Point__container.html#a3d8eb7234328742934933f6c017e151b",
"classCGAL_1_1Polyhedron__3.html#ae2a8fc92bccd3d00b602c3a18706ff67",
"classCGAL_1_1Polytope__distance__d__traits__3.html#ab62dc0da0342048e232baca7f5040caf",
"classCGAL_1_1Random__points__in__ball__d.html#a1a96fc6388ab7b049364d4c2969b1637",
"classCGAL_1_1Regular__triangulation__2.html#a5f06adae38f48d10cb02b258a1060d54",
"classCGAL_1_1Search__traits__3.html#af8672e70a7561375dea3dd356ed46bc3",
"classCGAL_1_1Segment__tree__k.html#a1249ef36cb734815360097ab4fea87e9",
"classCGAL_1_1Stream__lines__2.html#a6ba491a81c6b77b7f1ce4345b046d1ce",
"classCGAL_1_1Tree__anchor.html#a370b3fd28f310e9a0d23a42786365066",
"classCGAL_1_1Triangulation__2.html#a433cff4ceaeaba390df1a968d93a4899",
"classCGAL_1_1Triangulation__3.html#a5bea7d3470854571f97c18a675daca75a49588d4c5055e9403730d276b4f69649",
"classCGAL_1_1Triangulation__3.html#adfd1b39dcc103deb7da2cd11240bb882",
"classCGAL_1_1Uncertain.html#a00db673e4a80eddf0f5c153958d91e9e",
"classCGAL_1_1Voronoi__diagram__2.html#a6e53eabafbba071d5a93696e5943ae4e",
"classCircle.html#ace80f1af57a833a94054079fd03f7960",
"classCombinatorialMap.html#ad9cec590647daf6c3b106e911e9bc54b",
"classDelaunayGraph__2.html#af3ca989e9a8f170221a59374086b00be",
"classEnvelopeDiagram__1.html#a49bea489e630806972ddbfad29d48d14",
"classGeneralPolygon__2.html#a13c9ce25c0983fd9926d6f3a2637945a",
"classIntersectionGeometricTraits__3.html#a4eaf6c2bb851a932b50ae237a1be1416",
"classKernel.html#ad34fe10371a778e9f8b4b71c5455fd37",
"classKernel_1_1ComputeScalarProduct__2.html#a3c47639c8a9256df4a1d5a78cc800764",
"classKernel_1_1ConstructPerpendicularDirection__2.html",
"classKernel_1_1IsDegenerate__3.html#a5dc48e597385a16e47e6b49924332c5c",
"classLinearAlgebraTraits__d.html#a5a624020109c60d630e61ae3c9c06de0",
"classMeshDomainWithFeatures__3.html#aa45a2a11e40a886b17a98683e31364fe",
"classPQQMask__3.html#a324f5c8f71383e9e5be6052f266fe804",
"classPolygonIsValid.html",
"classPolynomialTraits__d_1_1Resultant.html#a4732bdc463f28146c38f6eb6bd1a0fcf",
"classRegularTriangulationTraits__3.html#aa48139f6580e103ceedde2995ddbff0f",
"classSparseLinearAlgebraTraits__d_1_1Vector.html",
"classStopPredicate.html#a3e94a06fa5a65ba80cd440f9de073f3f",
"classSurfaceModelingWeights.html",
"classTriangulationDataStructure__2.html#a040e1ee8457c0369c54aec67ce391a64",
"classTriangulationHierarchyVertexBase__2.html#a67b73a3c39bc5b99cf6c13901dba9a43",
"devman_intro.html#Developer_manualCorrectness",
"packages.html#PkgRidges_3Summary"
];

var SYNCONMSG = 'click to disable panel synchronisation';
var SYNCOFFMSG = 'click to enable panel synchronisation';
var navTreeSubIndices = new Array();

function getData(varName)
{
  var i = varName.lastIndexOf('/');
  var n = i>=0 ? varName.substring(i+1) : varName;
  return eval(n.replace(/\-/g,'_'));
}

function stripPath(uri)
{
  return uri.substring(uri.lastIndexOf('/')+1);
}

function stripPath2(uri)
{
  var i = uri.lastIndexOf('/');
  var s = uri.substring(i+1);
  var m = uri.substring(0,i+1).match(/\/d\w\/d\w\w\/$/);
  return m ? uri.substring(i-6) : s;
}

function localStorageSupported()
{
  try {
    return 'localStorage' in window && window['localStorage'] !== null && window.localStorage.getItem;
  }
  catch(e) {
    return false;
  }
}


function storeLink(link)
{
  if (!$("#nav-sync").hasClass('sync') && localStorageSupported()) {
      window.localStorage.setItem('navpath',link);
  }
}

function deleteLink()
{
  if (localStorageSupported()) {
    window.localStorage.setItem('navpath','');
  } 
}

function cachedLink()
{
  if (localStorageSupported()) {
    return window.localStorage.getItem('navpath');
  } else {
    return '';
  }
}

function getScript(scriptName,func,show)
{
  var head = document.getElementsByTagName("head")[0]; 
  var script = document.createElement('script');
  script.id = scriptName;
  script.type = 'text/javascript';
  script.onload = func; 
  script.src = scriptName+'.js'; 
  if ($.browser.msie && $.browser.version<=8) { 
    // script.onload does not work with older versions of IE
    script.onreadystatechange = function() {
      if (script.readyState=='complete' || script.readyState=='loaded') { 
        func(); if (show) showRoot(); 
      }
    }
  }
  head.appendChild(script); 
}

function createIndent(o,domNode,node,level)
{
  var level=-1;
  var n = node;
  while (n.parentNode) { level++; n=n.parentNode; }
  var imgNode = document.createElement("img");
  imgNode.style.paddingLeft=(16*level).toString()+'px';
  imgNode.width  = 16;
  imgNode.height = 22;
  imgNode.border = 0;
  if (node.childrenData) {
    node.plus_img = imgNode;
    node.expandToggle = document.createElement("a");
    node.expandToggle.href = "javascript:void(0)";
    node.expandToggle.onclick = function() {
      if (node.expanded) {
        $(node.getChildrenUL()).slideUp("fast");
        node.plus_img.src = node.relpath+"ftv2pnode.png";
        node.expanded = false;
      } else {
        expandNode(o, node, false, false);
      }
    }
    node.expandToggle.appendChild(imgNode);
    domNode.appendChild(node.expandToggle);
    imgNode.src = node.relpath+"ftv2pnode.png";
  } else {
    imgNode.src = node.relpath+"ftv2node.png";
    domNode.appendChild(imgNode);
  } 
}

var animationInProgress = false;

function gotoAnchor(anchor,aname,updateLocation)
{
  var pos, docContent = $('#doc-content');
  if (anchor.parent().attr('class')=='memItemLeft' ||
      anchor.parent().attr('class')=='fieldtype' ||
      anchor.parent().is(':header')) 
  {
    pos = anchor.parent().position().top;
  } else if (anchor.position()) {
    pos = anchor.position().top;
  }
  if (pos) {
    var dist = Math.abs(Math.min(
               pos-docContent.offset().top,
               docContent[0].scrollHeight-
               docContent.height()-docContent.scrollTop()));
    animationInProgress=true;
    docContent.animate({
      scrollTop: pos + docContent.scrollTop() - docContent.offset().top
    },Math.max(50,Math.min(500,dist)),function(){
      if (updateLocation) window.location.href=aname;
      animationInProgress=false;
    });
  }
}

function newNode(o, po, text, link, childrenData, lastNode)
{
  var node = new Object();
  node.children = Array();
  node.childrenData = childrenData;
  node.depth = po.depth + 1;
  node.relpath = po.relpath;
  node.isLast = lastNode;

  node.li = document.createElement("li");
  po.getChildrenUL().appendChild(node.li);
  node.parentNode = po;

  node.itemDiv = document.createElement("div");
  node.itemDiv.className = "item";

  node.labelSpan = document.createElement("span");
  node.labelSpan.className = "label";

  createIndent(o,node.itemDiv,node,0);
  node.itemDiv.appendChild(node.labelSpan);
  node.li.appendChild(node.itemDiv);

  var a = document.createElement("a");
  node.labelSpan.appendChild(a);
  node.label = document.createTextNode(text);
  node.expanded = false;
  a.appendChild(node.label);
  if (link) {
    var url;
    if (link.substring(0,1)=='^') {
      url = link.substring(1);
      link = url;
    } else {
      url = node.relpath+link;
    }
    a.className = stripPath(link.replace('#',':'));
    if (link.indexOf('#')!=-1) {
      var aname = '#'+link.split('#')[1];
      var srcPage = stripPath($(location).attr('pathname'));
      var targetPage = stripPath(link.split('#')[0]);
      a.href = srcPage!=targetPage ? url : "javascript:void(0)"; 
      a.onclick = function(){
        storeLink(link);
        if (!$(a).parent().parent().hasClass('selected'))
        {
          $('.item').removeClass('selected');
          $('.item').removeAttr('id');
          $(a).parent().parent().addClass('selected');
          $(a).parent().parent().attr('id','selected');
        }
        var anchor = $(aname);
        gotoAnchor(anchor,aname,true);
      };
    } else {
      a.href = url;
      a.onclick = function() { storeLink(link); }
    }
  } else {
    if (childrenData != null) 
    {
      a.className = "nolink";
      a.href = "javascript:void(0)";
      a.onclick = node.expandToggle.onclick;
    }
  }

  node.childrenUL = null;
  node.getChildrenUL = function() {
    if (!node.childrenUL) {
      node.childrenUL = document.createElement("ul");
      node.childrenUL.className = "children_ul";
      node.childrenUL.style.display = "none";
      node.li.appendChild(node.childrenUL);
    }
    return node.childrenUL;
  };

  return node;
}

function showRoot()
{
  var headerHeight = $("#top").height();
  var footerHeight = $("#nav-path").height();
  var windowHeight = $(window).height() - headerHeight - footerHeight;
  (function (){ // retry until we can scroll to the selected item
    try {
      var navtree=$('#nav-tree');
      navtree.scrollTo('#selected',0,{offset:-windowHeight/2});
    } catch (err) {
      setTimeout(arguments.callee, 0);
    }
  })();
}

function expandNode(o, node, imm, showRoot)
{
  if (node.childrenData && !node.expanded) {
    if (typeof(node.childrenData)==='string') {
      var varName    = node.childrenData;
      getScript(node.relpath+varName,function(){
        node.childrenData = getData(varName);
        expandNode(o, node, imm, showRoot);
      }, showRoot);
    } else {
      if (!node.childrenVisited) {
        getNode(o, node);
      } if (imm || ($.browser.msie && $.browser.version>8)) { 
        // somehow slideDown jumps to the start of tree for IE9 :-(
        $(node.getChildrenUL()).show();
      } else {
        $(node.getChildrenUL()).slideDown("fast");
      }
      if (node.isLast) {
        node.plus_img.src = node.relpath+"ftv2mlastnode.png";
      } else {
        node.plus_img.src = node.relpath+"ftv2mnode.png";
      }
      node.expanded = true;
    }
  }
}

function glowEffect(n,duration)
{
  n.addClass('glow').delay(duration).queue(function(next){
    $(this).removeClass('glow');next();
  });
}

function highlightAnchor()
{
  var aname = $(location).attr('hash');
  var anchor = $(aname);
  if (anchor.parent().attr('class')=='memItemLeft'){
    var rows = $('.memberdecls tr[class$="'+
               window.location.hash.substring(1)+'"]');
    glowEffect(rows.children(),300); // member without details
  } else if (anchor.parents().slice(2).prop('tagName')=='TR') {
    glowEffect(anchor.parents('div.memitem'),1000); // enum value
  } else if (anchor.parent().attr('class')=='fieldtype'){
    glowEffect(anchor.parent().parent(),1000); // struct field
  } else if (anchor.parent().is(":header")) {
    glowEffect(anchor.parent(),1000); // section header
  } else {
    glowEffect(anchor.next(),1000); // normal member
  }
  gotoAnchor(anchor,aname,false);
}

function selectAndHighlight(hash,n)
{
  var a;
  if (hash) {
    var link=stripPath($(location).attr('pathname'))+':'+hash.substring(1);
    a=$('.item a[class$="'+link+'"]');
  }
  if (a && a.length) {
    a.parent().parent().addClass('selected');
    a.parent().parent().attr('id','selected');
    highlightAnchor();
  } else if (n) {
    $(n.itemDiv).addClass('selected');
    $(n.itemDiv).attr('id','selected');
  }
  if ($('#nav-tree-contents .item:first').hasClass('selected')) {
    $('#nav-sync').css('top','30px');
  } else {
    $('#nav-sync').css('top','5px');
  }
  showRoot();
}

function showNode(o, node, index, hash)
{
  if (node && node.childrenData) {
    if (typeof(node.childrenData)==='string') {
      var varName    = node.childrenData;
      getScript(node.relpath+varName,function(){
        node.childrenData = getData(varName);
        showNode(o,node,index,hash);
      },true);
    } else {
      if (!node.childrenVisited) {
        getNode(o, node);
      }
      $(node.getChildrenUL()).show();
      if (node.isLast) {
        node.plus_img.src = node.relpath+"ftv2mlastnode.png";
      } else {
        node.plus_img.src = node.relpath+"ftv2mnode.png";
      }
      node.expanded = true;
      var n = node.children[o.breadcrumbs[index]];
      if (index+1<o.breadcrumbs.length) {
        showNode(o,n,index+1,hash);
      } else {
        if (typeof(n.childrenData)==='string') {
          var varName = n.childrenData;
          getScript(n.relpath+varName,function(){
            n.childrenData = getData(varName);
            node.expanded=false;
            showNode(o,node,index,hash); // retry with child node expanded
          },true);
        } else {
          var rootBase = stripPath(o.toroot.replace(/\..+$/, ''));
          if (rootBase=="index" || rootBase=="pages" || rootBase=="search") {
            expandNode(o, n, true, true);
          }
          selectAndHighlight(hash,n);
        }
      }
    }
  } else {
    selectAndHighlight(hash);
  }
}

function getNode(o, po)
{
  po.childrenVisited = true;
  var l = po.childrenData.length-1;
  for (var i in po.childrenData) {
    var nodeData = po.childrenData[i];
    po.children[i] = newNode(o, po, nodeData[0], nodeData[1], nodeData[2],
      i==l);
  }
}

function gotoNode(o,subIndex,root,hash,relpath)
{
  var nti = navTreeSubIndices[subIndex][root+hash];
  o.breadcrumbs = $.extend(true, [], nti ? nti : navTreeSubIndices[subIndex][root]);
  if (!o.breadcrumbs && root!=NAVTREE[0][1]) { // fallback: show index
    navTo(o,NAVTREE[0][1],"",relpath);
    $('.item').removeClass('selected');
    $('.item').removeAttr('id');
  }
  if (o.breadcrumbs) {
    o.breadcrumbs.unshift(0); // add 0 for root node
    showNode(o, o.node, 0, hash);
  }
}

function navTo(o,root,hash,relpath)
{
  var link = cachedLink();
  if (link) {
    var parts = link.split('#');
    root = parts[0];
    if (parts.length>1) hash = '#'+parts[1];
    else hash='';
  }
  if (hash.match(/^#l\d+$/)) {
    var anchor=$('a[name='+hash.substring(1)+']');
    glowEffect(anchor.parent(),1000); // line number
    hash=''; // strip line number anchors
    //root=root.replace(/_source\./,'.'); // source link to doc link
  }
  var url=root+hash;
  var i=-1;
  while (NAVTREEINDEX[i+1]<=url) i++;
  if (i==-1) { i=0; root=NAVTREE[0][1]; } // fallback: show index
  if (navTreeSubIndices[i]) {
    gotoNode(o,i,root,hash,relpath)
  } else {
    getScript(relpath+'navtreeindex'+i,function(){
      navTreeSubIndices[i] = eval('NAVTREEINDEX'+i);
      if (navTreeSubIndices[i]) {
        gotoNode(o,i,root,hash,relpath);
      }
    },true);
  }
}

function showSyncOff(n,relpath)
{
    n.html('<img src="'+relpath+'sync_off.png" title="'+SYNCOFFMSG+'"/>');
}

function showSyncOn(n,relpath)
{
    n.html('<img src="'+relpath+'sync_on.png" title="'+SYNCONMSG+'"/>');
}

function toggleSyncButton(relpath)
{
  var navSync = $('#nav-sync');
  if (navSync.hasClass('sync')) {
    navSync.removeClass('sync');
    showSyncOff(navSync,relpath);
    storeLink(stripPath2($(location).attr('pathname'))+$(location).attr('hash'));
  } else {
    navSync.addClass('sync');
    showSyncOn(navSync,relpath);
    deleteLink();
  }
}

function initNavTree(toroot,relpath)
{
  var o = new Object();
  o.toroot = toroot;
  o.node = new Object();
  o.node.li = document.getElementById("nav-tree-contents");
  o.node.childrenData = NAVTREE;
  o.node.children = new Array();
  o.node.childrenUL = document.createElement("ul");
  o.node.getChildrenUL = function() { return o.node.childrenUL; };
  o.node.li.appendChild(o.node.childrenUL);
  o.node.depth = 0;
  o.node.relpath = relpath;
  o.node.expanded = false;
  o.node.isLast = true;
  o.node.plus_img = document.createElement("img");
  o.node.plus_img.src = relpath+"ftv2pnode.png";
  o.node.plus_img.width = 16;
  o.node.plus_img.height = 22;

  if (localStorageSupported()) {
    var navSync = $('#nav-sync');
    if (cachedLink()) {
      showSyncOff(navSync,relpath);
      navSync.removeClass('sync');
    } else {
      showSyncOn(navSync,relpath);
    }
    navSync.click(function(){ toggleSyncButton(relpath); });
  }

  navTo(o,toroot,window.location.hash,relpath);

  $(window).bind('hashchange', function(){
     if (window.location.hash && window.location.hash.length>1){
       var a;
       if ($(location).attr('hash')){
         var clslink=stripPath($(location).attr('pathname'))+':'+
                               $(location).attr('hash').substring(1);
         a=$('.item a[class$="'+clslink+'"]');
       }
       if (a==null || !$(a).parent().parent().hasClass('selected')){
         $('.item').removeClass('selected');
         $('.item').removeAttr('id');
       }
       var link=stripPath2($(location).attr('pathname'));
       navTo(o,link,$(location).attr('hash'),relpath);
     } else if (!animationInProgress) {
       $('#doc-content').scrollTop(0);
       $('.item').removeClass('selected');
       $('.item').removeAttr('id');
       navTo(o,toroot,window.location.hash,relpath);
     }
  })

  $(window).load(showRoot);
}

